﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics;
using Infragistics.Controls.Charts;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<InstalationEmissionDateInformation> RetVal { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            RetVal = new ObservableCollection<InstalationEmissionDateInformation>();
        }

        private void MainWindow_OnLoaded(object sender, RoutedEventArgs e)
        {
            GroupBy gb = new GroupBy();
            gb.GroupMemberPath = "Date";
            gb.KeyMemberPath = "Installation";
            gb.ValueMemberPath = "Emission";

            RetVal = TestEmissionsCollection.GetItemSource();
            gb.ItemsSource = RetVal;

            Infragistics.Controls.Charts.NumericYAxis yAxis = new NumericYAxis();
            CategoryXAxis xAxis = new CategoryXAxis();
            xAxis.ItemsSource = gb;
            // xAxis.Label = Resources["labels"] as DataTemplate;
            xAxis.Label = "{Key}";
            this.theChart.Axes.Add(xAxis);
            this.theChart.Axes.Add(yAxis);

            StackedAreaSeries series = new StackedAreaSeries();

            series.XAxis = xAxis;
            series.YAxis = yAxis;
            series.ItemsSource = gb;
            series.AutoGenerateSeries = true;
            theChart.Series.Add(series);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            RetVal.Add(new InstalationEmissionDateInformation("E", 9, "1/1/2012", 1));
            RetVal.Add(new InstalationEmissionDateInformation("E", 3, "1/2/2012", 1));
            RetVal.Add(new InstalationEmissionDateInformation("E", 6, "1/4/2012", 1));
        }
    }

    public class TestEmissionsCollection
    {

        public static ObservableCollection<InstalationEmissionDateInformation> GetItemSource()
        {
            ObservableCollection<InstalationEmissionDateInformation> retVal = new ObservableCollection<InstalationEmissionDateInformation>();

            retVal.Add(new InstalationEmissionDateInformation("A", 5, "1/1/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("B", 2, "1/1/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("C", 7, "1/1/2012", 1));

            retVal.Add(new InstalationEmissionDateInformation("A", 6, "1/2/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("B", 3, "1/2/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("C", 8, "1/2/2012", 1));

            retVal.Add(new InstalationEmissionDateInformation("A", 6, "1/3/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("B", 3, "1/3/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("C", 6, "1/3/2012", 1));

            retVal.Add(new InstalationEmissionDateInformation("A", 4, "1/4/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("B", 3, "1/4/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("C", 7, "1/4/2012", 1));

            retVal.Add(new InstalationEmissionDateInformation("D", 7, "1/1/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("D", 8, "1/2/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("D", 6, "1/3/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("D", 7, "1/4/2012", 1));

            

            return retVal;
        }

        public TestEmissionsCollection()
        {

        }
    }

    public class InstalationEmissionDateInformation
    {
        public string Installation { get; set; }
        public Decimal Emission { get; set; }
        public string Date { get; set; }
        public Decimal Assignation { get; set; }

        public InstalationEmissionDateInformation(
            string installation,
            Decimal emission,
            string date,
            Decimal assignation)
        {
            Installation = installation;
            Emission = emission;
            Date = date;
            Assignation = assignation;
        }
    }
}